<?php

namespace App\Presenters;

use App\Components\ManageFavoritesControl;
use App\Model\Comment;
use App\Model\Orm;
use App\Model\Kategorie;
use App\Model\Rating;
use App\Model\Serialy;
use App\Model\User;
use Nette;
use Nette\Application\UI\Form;
use Nette\ComponentModel\IComponent;
use Tracy\Debugger;

class SerialPresenter extends BasePresenter
{
    public Serialy $serial;
    public User $databaseUser;
    public Rating $rating;

    public function createComponentSerialForm(): Form
    {
        
        $form = new Form;

        $form->addText('nazev', 'Název:')
            ->setRequired('Zadejte název seriálu');

        $form->addTextArea('popis', 'Popis:')
            ->addRule(Form::FILLED,'Musí být vyplněn popis seriálu.')
            ->addRule(Form::MAX_LENGTH,'Maximální délka popisu je 255 znaků',255);


        $form->addText('delka', 'Průměrná délka dílu (min):')
         ->addRule(Form::FILLED,'Musí být vyplněna délka seriálu.')
            ->addCondition(Form::INTEGER);

        $form->addCheckboxList('kategorie', 'Kategorie:', $this->orm->kategorie->findAll()->fetchPairs('id','name'));

        $form->addText('trailer', 'Trailer');

        $form->addText('publicationYear');


        //dodělat možnost přidání herců
        $form->addSubmit('odeslat', 'Odeslat');

        $form->onSuccess[]=[$this,'contactFormSucces2'];
        $form->onValidate[] = [$this, 'formValidate'];
        return $form;
    }

    public function formValidate(Form $form)
    {
        $values = $form->getValues();
        if (is_int($values->delka))
        {
            return TRUE;
        } else {
            $form->addError('chyba, delka musi byt cislo');
            return FALSE;
        }
    }
    

    public function contactFormSucces2(Form $form): void
    {

        
        $values = $form->getValues();
        $serials = new Serialy();
        $serials->nazev=$values->nazev;
        $serials->popis=$values->popis;
        $serials->delka=$values->delka;
        $serials->trailer=$values->trailer;
        $serials->publicationYear=$values->publicationYear;
        foreach ($values->kategorie as $idKategorie){
            $kategorie=$this->orm->kategorie->getById($idKategorie);
            $serials->kategorie->add($kategorie);
        }
        $this->orm->persistAndFlush($serials);
        $this->flashMessage('Seriál byl úspěšně zapsán do seznamu.');
        $this->redirect('default');
    }

    public function startup()
    {
        parent::startup(); // TODO: Change the autogenerated stub
        if ($this->getUser()->isLoggedIn()) {
            $this->databaseUser=$this->orm->users->getBy(['loginName'=>$this->user->id]);
        }
    }

    public function actionDefault($page=1)
    {
        $serialy = $this->orm->serialy->findAll();

        $paginator = new Nette\Utils\Paginator();
        $paginator->setPage($page); // číslo aktuální stránky
        $paginator->setItemsPerPage(6); // počet položek na stránce
        $paginator->setItemCount($serialy->countStored()); // celkový počet položek, je-li znám
        $this->template->seznam=$serialy->limitBy($paginator->getItemsPerPage(),$paginator->getOffset());
        $this->template->paginator=$paginator;

        $category=$this->orm->kategorie->findAll();
        $this->template->category=$category;

        //najdi mi všechny seriály, které budou seřazeny od největšího počtu kliknutí po nejmenší
        $oblibeneSerialy=$this->orm->serialy->findAll()->limitBy(3)->orderBy('viewCount','DESC');
        $this->template->oblibeneSerialy=$oblibeneSerialy;



    }

    public function handleViewCounter($id)
    {
        $serial=$this->orm->serialy->getById($id);
        $serial->viewCount=$serial->viewCount+1;
        $this->orm->persistAndFlush($serial);
        $this->redirect('Serial:detail',[$id]);
    }

    public function renderDetail($id)
    {
        //sčítač počtu hodnocení
        $this->template->ratings = $this->orm->ratings->findBy(['this->serialy->id'=>$id])->count('value');


    }

    public function actionDetail($id, $serie)
    {
        if (!$this->getUser()->isLoggedIn()) {
            $this->redirect('Homepage:default');
        }
        $serial=$this->orm->serialy->getById($id);
        $this->serial = $serial;
        $this->template->serial=$serial;


        $kategorie = $serial->kategorie->get()->findBy([]); //vytahnu si všechny kategorie serialu
        $poleIdcekKategorii = $kategorie->fetchPairs(null, 'id'); //z Kolekce kategorii si vytahnu pouze idcka do pole
        $offerSerials=$this->orm->serialy->findBy(['this->kategorie->id'=>$poleIdcekKategorii])->limitBy(3);
        $this->template->offerSerials=$offerSerials;

        $comment=$this->orm->comment->findBy(['this->serialy->id'=>$id]);
        $this->template->comment=$comment;


        $serieSerial = $this->orm->serie->findBy(['this->serialy->id'=>$id]);
        $this->template->serieSerial=$serieSerial;

        //$partSerial = $this->orm->part->findBy(['this->serie->serialy'=>$id])->fetchPairs('serialy','serie');
        //$this->template->partSerial=$partSerial;


    }

    public function actionCategory($id,$page=1)
    {
        $categor=$this->orm->serialy->findBy(['this->kategorie->id'=>$id]);


        $paginatorCategory = new Nette\Utils\Paginator();
        $paginatorCategory->setPage($page); // číslo aktuální stránky
        $paginatorCategory->setItemsPerPage(6); // počet položek na stránce
        $paginatorCategory->setItemCount($categor->countStored()); // celkový počet položek, je-li znám
        $this->template->categor=$categor->limitBy($paginatorCategory->getItemsPerPage(),$paginatorCategory->getOffset());
        $this->template->paginatorCategory=$paginatorCategory;

        $category=$this->orm->kategorie->findAll();
        $this->template->category=$category;
        $actualyCategory=$this->orm->kategorie->getBy(['id'=>$id]);
        $this->template->actualyCategory=$actualyCategory;


    }

    public function actionEdit($id)
    {
        if (!$this->getUser()->isLoggedIn()) {
		$this->redirect('Login:in');
        }
        $serial = $this->orm->serialy->getById($id);
        $this->serial = $serial;
        $this->template->serial = $serial;
        
    }

    public function createComponentEditForm(): Form
    {
        $form = new Form;

        $form->addText('nazev', 'Název:')
            ->setRequired('Zadejte název seriálu')
            ->setDefaultValue($this->serial->nazev);

        $form->addTextArea('popis', 'Popis:')
            ->addRule(Form::FILLED,'Musí být vyplněn popis seriálu.')
            ->setDefaultValue($this->serial->popis);


        $form->addText('delka', 'Délka  (min):')
            ->addRule(Form::FILLED,'Musí být vyplněna délka seriálu.')
            ->setDefaultValue($this->serial->delka);

        $form->addCheckboxList('kategorie', 'Kategorie:', $this->orm->kategorie->findAll()->fetchPairs('id','name'))
            ->addRule(Form::FILLED,'Musí být vyplněna kategorie seriálu.')
            ->setDefaultValue($this->serial->kategorie->get()->findBy([])->fetchPairs(null, 'id'));

        //dodělat možnost přidání herců
        $form->addSubmit('odeslat', 'Odeslat');

        $form->onSuccess[]=[$this,'editFormSuccess'];
        return $form;
    }

    public function editFormSuccess(Form $form, Nette\Utils\ArrayHash $values)
    {
        $values = $form->getValues();
        $serials = $this->serial;
        $serials->nazev=$values->nazev;
        $serials->popis=$values->popis;
        $serials->delka=$values->delka;

        foreach ($serials->kategorie as $kategorie)
        {
            $serials->kategorie->remove($kategorie);
            $this->orm->persistAndFlush($serials);
        }

        foreach ($values->kategorie as $idKategorie){
            $kategorie=$this->orm->kategorie->getById($idKategorie);
            $serials->kategorie->add($kategorie);
        }

        $this->orm->persistAndFlush($serials);
        $this->flashMessage('Seriál byl úspěšně upraven.');
        Debugger::barDump($values);
        $this->redirect('default');
    }


    public function handleAddToFavourite($serialId)
    {
        if (isset($this->databaseUser)){

            $serial=$this->orm->serialy->getById($serialId);
        $this->databaseUser->serialy->add($serial);
        $this->orm->persistAndFlush($this->databaseUser);
        $this->flashMessage('Seriál byl úspěšně přidán do seznamu oblíbených.');
        }else
            {
            $this->flashMessage('Pro více možností musí být uživatel přihlášený.');

        }
    }

    public function addUserSerialFavourite(Serialy $serialy)
    {
        //musí být get()->getById jinak to nefunguje
        if (isset($this->databaseUser)){
        $favouriteSerial=$this->databaseUser->serialy->get()->getById($serialy->id);
        if($favouriteSerial)
        {
            return true;
        } else
        {
            return false;
        }
        }else{
            $this->flashMessage('Pro více možností musí být uživatel přihlášený.');

        }
    }

    public function handleRemoveFavourite($serialId)
    {
        $serial=$this->orm->serialy->getById($serialId);
        $this->databaseUser->serialy->remove($serial);
        $this->orm->persistAndFlush($this->databaseUser);
        $this->flashMessage('Seriál byl úspěšně odebrán ze seznamu oblíbených.');
    }

    public function createComponentManageFavorite(string $name): ?IComponent
    {
        $component = new ManageFavoritesControl($this->databaseUser, $this->orm);

        return $component;
    }

    public function functionComment()
    {
        $comment=$this->orm->comment->findAll();
        $this->template->comment=$comment;
    }


    public function createComponentCommentForm(): Form
    {

        $form = new Form;

        $form->addTextArea('content', 'Komentář k seriálu:')
            ->setRequired('Toto pole je povinné')
            ->addRule(Form::MAX_LENGTH,'Maximální délka komentáře je 255 znaků',255);


        $form->addTextArea('author', 'Jméno:')
            ->addRule(Form::FILLED,'Toto pole je povinné');


        $form->addText('email', 'E-mail:')
            ->addRule(Form::FILLED,'Toto pole je povinné');

        $form->addSubmit('send', 'Přidat komentář:');

        $form->onSuccess[]=[$this,'commentFormSucces'];
        return $form;
    }

    public function commentFormSucces (Form $form): void
    {


        $values = $form->getValues();
        $comment = new Comment();
        $comment->content=$values->content;
        $comment->author=$values->author;
        $comment->email=$values->email;
        $comment->serialy=$this->serial;

        $this->orm->persistAndFlush($comment);
        $this->flashMessage('Komentář byl přidán.');
        $this->redirect('detail', ['id'=>$this->serial->id]);
    }

    public function handleRemoveComment($commentId)
    {

            $comment=$this->orm->comment->getById($commentId);
            if ($comment)
            {
                $this->orm->remove($comment);
                $this->orm->flush();
                $this->flashMessage('Komentář byl smazán.');
                }else
                    {
                $this->flashMessage('Komentář nebyl nalezen.');
            }
    }

    public function handleAddRating($value)
    {
        //vkládání hodnot do databáze
        //předávám hodnotu value do databáze
        $rating = new Rating();
        $rating->value=$value;
        $rating->serialy=$this->serial; //defunuju handlu co je to serial

        $this->orm->persistAndFlush($rating);
        $this->flashMessage('Hodnocení bylo úspěšné!');
        $this->redirect('this');
    }

    public function avgRating($serialyId)
    {
        $avg=$this->orm->ratings->getById($serialyId);
        $this->template->avg=$avg;
    }

    public function actionPart($part)
    {
        $partDetail = $this->orm->serialy->getById($part);
        $this->template->partDetail=$partDetail;
    }






}